SystemOrganization addCategory: 'Seaside-GemStone-Tools-Production-Gems'!
SystemOrganization addCategory: 'Seaside-GemStone-Tools-Production-ObjectLog'!

!Collection methodsFor: '*seaside-gemStone-tools-production' stamp: 'lr 5/9/2007 08:47'!
inspectorFields
	| i |
	i := 0.
	^ self asArray collect: [ :each | i := i + 1. i -> each ]! !

!AbstractDictionary methodsFor: '*seaside-gemStone-tools-production' stamp: 'DaleHenrichs 08/24/2010 09:19'!
inspectorFields
	^ self associations! !

!BlockClosure methodsFor: '*seaside-gemStone-tools-production' stamp: 'DaleHenrichs 07/06/2010 12:02'!
inspectorFields
	"not very interesting to look at guts of Blocks..."
	^#()! !

WAComponent subclass: #WAObjectLog
	instanceVariableNames: 'summaryReport report filter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-GemStone-Tools-Production-ObjectLog'!

!WAObjectLog class methodsFor: 'testing' stamp: 'jgf 11/16/2009 13:02'!
canBeRoot
	^ true! !

!WAObjectLog class methodsFor: 'accessing' stamp: 'jgf 11/16/2009 13:02'!
description
	^ 'Seaside component for viewing OTRemoteDebugger object log contents.'! !

!WAObjectLog class methodsFor: 'accessing' stamp: 'jgf 11/16/2009 13:02'!
entryPointName
	^'tools/objectLog'! !

!WAObjectLog class methodsFor: 'initialization' stamp: 'DaleHenrichs 07/06/2010 18:32'!
initialize
	"WAAdmin register: self asApplicationAt: self entryPointName"! !

!WAObjectLog methodsFor: 'accessing' stamp: 'jgf 11/16/2009 13:02'!
children
	^ Array with: report with: summaryReport! !

!WAObjectLog methodsFor: 'actions' stamp: 'jgf 11/16/2009 13:02'!
deleteAllAtPriority: aSummaryEntry

	| priority log |
	priority := aSummaryEntry key.
	log := self objectLogEntries: true.
	(log select: [:ea | ea priority == priority ]) do: [:ea |  log remove: ea ifAbsent: []].! !

!WAObjectLog methodsFor: 'actions' stamp: 'jgf 11/16/2009 13:02'!
deleteLogEntriesUpToInclusive: anObjectLogEntry

	| entries index log |
	entries := report rows.
	index := entries indexOf: anObjectLogEntry.
	log := self objectLogEntries: true.
	(entries copyFrom: 1 to: index) do: [:ea |
		 log remove: ea ifAbsent: []].! !

!WAObjectLog methodsFor: 'actions' stamp: 'jgf 11/16/2009 13:02'!
deleteLogEntry: anObjectLogEntry

	|  log |
	log := self objectLogEntries: true.
	log remove: anObjectLogEntry ifAbsent: []! !

!WAObjectLog methodsFor: 'initialization' stamp: 'DaleHenrichs 07/06/2010 12:22'!
initialize
	| columns summaryColumns labels |
	super initialize.
	columns := (OrderedCollection new)
		add: ((WAReportColumn
			selector: #priorityString title: 'priority')
			sortBlock: [:a :b | a < b ];
			clickBlock: [:each | self call: (WAObjectLogInspector on: each)]);
		add: ((WAReportColumn
			selector: #labelText title: 'Label')
			formatBlock: [:ea | ea ];
			sortBlock: [:a :b | a asString < b asString]);
		add: ((WAReportColumn
			selector: #pidString title: 'pid')
			sortBlock: [:a :b | a asNumber < b asNumber ]);
		add: ((WAReportColumn
			selector: #stampString 
			title: 'time')
			sortBlock: [:a :b | a > b ]);
		add: ((WAReportColumn
			selector: #requestString
			title: 'url')
			sortBlock: [:a :b | a < b ]);
		add: ((WAReportColumn
			selector: #objectString 
			title: 'object')
			sortBlock: [:a :b | a asString < b asString]);
		add: ((WAReportColumn
			selector: #deleteString title: 'delete down to'
			onClick: [ :each | self deleteLogEntriesUpToInclusive: each ])
			sortBlock: nil);
		add: ((WAReportColumn
			renderBlock: [ :each :html | 
				html anchor
					callback: [ self deleteLogEntry: each ];
					title: 'delete entry';
					with: 'me' ]
			title: 'delete')
			sortBlock: nil);
		yourself.
	report := WAObjectLogTableReport new
		rows: self objectLogEntries;
		columns: columns;
		rowColors: #(lightblue lightyellow);
		rowPeriod: 1;
		yourself.
	labels := self labels.
	summaryColumns := (OrderedCollection new)
		add: ((WAReportColumn
			renderBlock: [ :each :html | 
				html text: (labels at: each key) ]
			title: 'name')
			sortBlock: nil);
		add: ((WAReportColumn
			selector: #key title: 'priority')
			sortBlock: [:a :b | a < b ]);
		add: ((WAReportColumn
			selector: #value title: 'count')
			sortBlock: [:a :b | a < b ]);
		add: ((WAReportColumn
			renderBlock: [ :each :html | 
				each value == 0
					ifTrue: [ html text: '-' ]
					ifFalse: [
						html anchor
							callback: [ self deleteAllAtPriority: each ];
							title: 'delete';
							with: 'all ', (labels at: each key)] ]
			title: 'delete')
			sortBlock: nil);
		yourself.
	summaryReport := WAObjectLogTableReport new
		rows: self objectLogSummary;
		columns: summaryColumns;
		rowPeriod: 1;
		yourself.! !

!WAObjectLog methodsFor: 'initialization' stamp: 'DaleHenrichs 06/20/2010 10:28'!
labels

	^#('fatal' 'error' 'warn' 'info' 'debug' 'trace' 'transcript').! !

!WAObjectLog methodsFor: 'accessing' stamp: 'jgf 11/16/2009 13:02'!
objectLogEntries

	^ self objectLogEntries: false! !

!WAObjectLog methodsFor: 'accessing' stamp: 'jgf 11/16/2009 13:02'!
objectLogEntries: shouldLock

	shouldLock 
		ifTrue: [
			System writeLock: ObjectLogEntry objectQueue
				ifDenied: [ 
					WARetryHttpRequest signal: 'ObjectLogEntry objectQueue lock denied'.
					"does not return" ]
				ifChanged: [ 
					System addToCommitOrAbortReleaseLocksSet: ObjectLogEntry objectQueue.
					WARetryHttpRequest signal: 'ObjectLogEntry objectQueue lock dirty'.
					"does not return" ].
			System addToCommitOrAbortReleaseLocksSet: ObjectLogEntry objectQueue].
	^ObjectLogEntry objectLog! !

!WAObjectLog methodsFor: 'accessing' stamp: 'DaleHenrichs 06/20/2010 10:30'!
objectLogSummary

	| sums summary |
	sums := Dictionary new.
	1 to: self labels size do: [:i | sums at: i put: 0 ].
	self objectLogEntries do: [:ea | | tally |
		tally := sums at: ea priority.
		sums at: ea priority put: (tally + 1)].
	summary := Array new: self labels size.
	1 to: self labels size do: [:i| summary at: i put: (sums associationAt: i) ].
	^summary! !

!WAObjectLog methodsFor: 'rendering' stamp: 'jgf 11/16/2009 13:05'!
renderContentOn: html

	| rows |
	html heading: 'Object Log [', self objectLogEntries size printString, ']'.
	self renderSummaryOn: html.
	self renderFormOn: html.
	rows := self objectLogEntries reversed.
	filter notNil ifTrue: [
		| index |
		index := self labels indexOf: filter.
		rows := rows select: [:each | each priority = index].
	].
	report rows: rows.
	html render: report! !

!WAObjectLog methodsFor: 'rendering' stamp: 'jgf 11/16/2009 13:14'!
renderFormOn: html

	html form: [
		html div: [
			html label: 'Filter: '.
			html select
				list: self labels;
				beOptional;
				optionalLabel: '-- Show All --';
				selected: filter;
				callback: [:value | filter := value];
				yourself.
			html submitButton: 'Update'.
		].
	].! !

!WAObjectLog methodsFor: 'rendering' stamp: 'jgf 11/16/2009 13:02'!
renderSummaryOn: html

	summaryReport rows: self objectLogSummary.
	html render: summaryReport! !

WAComponent subclass: #WAObjectLogInspector
	instanceVariableNames: 'path selected input'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-GemStone-Tools-Production-ObjectLog'!

!WAObjectLogInspector class methodsFor: 'instance creation' stamp: 'DaleHenrichs 07/06/2010 11:23'!
on: anObject
	^ self new object: anObject; yourself! !

!WAObjectLogInspector methodsFor: 'actions' stamp: 'DaleHenrichs 07/06/2010 11:23'!
actions
	"A list of action selectors used to render buttons in the Inspector."

	^ #(doIt inspectIt)! !

!WAObjectLogInspector methodsFor: 'hooks' stamp: 'DaleHenrichs 07/06/2010 11:23'!
children
	^ Array with: path! !

!WAObjectLogInspector methodsFor: 'actions' stamp: 'DaleHenrichs 07/06/2010 11:23'!
chooseObject: anObject named: aString
	"Choose a new object to be inspected, adding aString to the navigation path."

	path pushSegment: anObject name: aString.
	selected := nil! !

!WAObjectLogInspector methodsFor: 'actions' stamp: 'DaleHenrichs 07/06/2010 11:28'!
displayFullPrintStringFor: anObject

	self call: (WAStringInspector new
		string: anObject printString;
		yourself)! !

!WAObjectLogInspector methodsFor: 'actions' stamp: 'DaleHenrichs 07/06/2010 11:28'!
doIt
	| result |
	result := super doIt.
	selected ifNil: [ ^ result ].
	^ selected isNumber
		ifTrue: [ self object at: selected put: result ]
		ifFalse: [ self object instVarNamed: selected put: result ]! !

!WAObjectLogInspector methodsFor: 'actions' stamp: 'DaleHenrichs 07/06/2010 11:28'!
evaluate
	"GemStone does not have a thisContext variable..."

	^input evaluateInContext: self object symbolList: GsSession currentSession symbolList! !

!WAObjectLogInspector methodsFor: 'private' stamp: 'DaleHenrichs 07/06/2010 11:29'!
fieldsFor: anObject
	^ anObject inspectorFields! !

!WAObjectLogInspector methodsFor: 'initialization' stamp: 'DaleHenrichs 07/06/2010 11:23'!
initialize
	super initialize.
	path := WAPath new! !

!WAObjectLogInspector methodsFor: 'actions' stamp: 'DaleHenrichs 07/06/2010 11:23'!
inspectIt
	"Evaluate the code in the textarea and then inspect the result."
	| result |
	result := self evaluate.
	self 
		chooseObject: result
		named: result greaseString! !

!WAObjectLogInspector methodsFor: 'testing' stamp: 'DaleHenrichs 07/06/2010 11:23'!
isPrimitiveType: anObject
	"Return a boolean indicating whether anObject is a primitive type in the system.
	Primitive types will not be rendered with a link allowing them to be inspected."

	^ anObject isNumber or: [ #(nil true false) includes: anObject ]! !

!WAObjectLogInspector methodsFor: 'accessing' stamp: 'DaleHenrichs 07/06/2010 11:23'!
object
	^ path currentSegment! !

!WAObjectLogInspector methodsFor: 'accessing' stamp: 'DaleHenrichs 07/06/2010 11:23'!
object: anObject 
	self 
		chooseObject: anObject
		named: anObject greaseString! !

!WAObjectLogInspector methodsFor: 'rendering' stamp: 'DaleHenrichs 07/06/2010 11:23'!
renderContentOn: html
	html heading
		level: 1;
		with: (self object printStringLimitedTo: 50).
	html render: path.
	html form: [
		self renderMembersOn: html.
		self renderEditAreaOn: html ]! !

!WAObjectLogInspector methodsFor: 'rendering' stamp: 'DaleHenrichs 07/06/2010 11:23'!
renderEditAreaOn: html
	html textArea
		value: input;
		callback: [ :value | input := value ].
	html break.
	self actions do: [ :each |
		html submitButton
			callback: [ self perform: each ];
			text: each ]! !

!WAObjectLogInspector methodsFor: 'rendering' stamp: 'DaleHenrichs 07/06/2010 11:23'!
renderMembersOn: html
	| members radioGroup |
	selected := nil.
	members := self fieldsFor: self object.
	members isEmpty ifTrue: [ ^ self ].
	radioGroup := html radioGroup.
	radioGroup
		callback: [ :value | selected := value ];
		selected: selected.
	html table: [
		members do: [ :association |
			self
				renderRow: association value
				named: association key
				group: radioGroup
				on: html ] ]! !

!WAObjectLogInspector methodsFor: 'rendering' stamp: 'DaleHenrichs 07/06/2010 11:29'!
renderRow: anObject named: aString group: aRadioGroup on: html
	| radioButton |
	html tableRow: [
		html tableHeading: [
			radioButton := aRadioGroup radioButton
				ensureId;
				value: aString;
				yourself.
			html label for: radioButton id; with: [
				(self isPrimitiveType: anObject)
					ifTrue: [ html text: aString ]
					ifFalse: [
						html anchor
							callback: [ self chooseObject: anObject named: aString ];
							with: aString ] ] ].
		html tableData: [ | str |
			str := anObject printStringLimitedTo: 100.
			str size > 90
				ifTrue: [
					html anchor
						callback: [ self displayFullPrintStringFor: anObject ];
						with: str]
				ifFalse: [
					html text: str]] ]! !

!WAObjectLogInspector methodsFor: 'hooks' stamp: 'DaleHenrichs 07/06/2010 11:23'!
style
	^ 'form {
	padding: 2px;
	margin: 0;
}
form th {
	text-align: left;
	padding-right: 2em;
}
form textarea {
	width: 100%;
	height: 100px;
	border: 1px solid #aaa;
}'! !

WAComponent subclass: #WAStringInspector
	instanceVariableNames: 'string'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-GemStone-Tools-Production-ObjectLog'!

!WAStringInspector methodsFor: 'rendering' stamp: 'dkh 04/18/2008 15:56'!
renderContentOn: html

	html preformatted: self string! !

!WAStringInspector methodsFor: 'accessing' stamp: 'dkh 04/18/2008 15:56'!
string

	^string! !

!WAStringInspector methodsFor: 'accessing' stamp: 'dkh 04/18/2008 15:56'!
string: aString

	string := aString! !

WATableReport subclass: #WAObjectLogTableReport
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-GemStone-Tools-Production-ObjectLog'!

!WAObjectLogTableReport methodsFor: 'rendering' stamp: 'dkh 04/18/2008 10:42'!
renderColumn: aColumn row: aRow on: html
	| text |
	aColumn canRender ifTrue: [
		^html tableData: [aColumn renderValue: aRow on: html]].
	text := aColumn textForRow: aRow.
	text isEmpty ifTrue: [ text := ' ' ].
	html tableData: [
		aColumn canChoose
			ifFalse: [ html render: text ]
			ifTrue: [
				html anchor
					callback: [ self chooseRow: aRow column: aColumn ];
					with: text ] ]! !

!Object methodsFor: '*seaside-gemStone-tools-production' stamp: 'dkh 11/10/2009 14:25'!
inspectorFields
	| members |
	members := Array new writeStream.
	self class allInstVarNames withIndexDo: [ :each :index |
		members nextPut: each -> (self instVarAt: index) ].
	self class isVariable ifTrue: [
		1 to: self size do: [ :index |
			members nextPut: index -> (self at: index) ] ].
	^ members contents! !

Object subclass: #WAGemStoneMaintenanceTask
	instanceVariableNames: 'name frequency valuable state resetBlock'
	classVariableNames: 'Tasks'
	poolDictionaries: ''
	category: 'Seaside-GemStone-Tools-Production-Gems'!

!WAGemStoneMaintenanceTask class methodsFor: 'initialization' stamp: 'DaleHenrichs 07/06/2010 14:50'!
buildTaskList
	"self buildTaskList"

	(self class allSelectors select: [:ea | ea beginsWith: 'maintenanceTask' ]) do:[:selector | | task |
		task := self perform: selector.
		"add task only if it isn't already in task list"
		self taskNamed: task name ifAbsent: [ self tasks add: task ]].! !

!WAGemStoneMaintenanceTask class methodsFor: 'initialization' stamp: 'DaleHenrichs 07/06/2010 14:30'!
initialize
	"self initialize"
	
	Tasks := nil.
	self buildTaskList! !

!WAGemStoneMaintenanceTask class methodsFor: 'default maintenance tasks' stamp: 'DaleHenrichs 07/06/2010 17:06'!
maintenanceTaskExpiration
	"self initialize"
	"self performTasks: 1"
	
	" run session expiration once each minute"
	
	^self 
		name: 'Seaside Session Expiration'
		frequency: 1
		valuable: [:task | | expired expirations transactionMode |
  			GsFile gciLogServer: 'Unregistering...', DateAndTime now printString.
			transactionMode := System transactionMode.
   			transactionMode ~~ #autoBegin ifTrue: [ System transactionMode: #autoBegin ].
  			expirations := task state.
  			System _sessionCacheStatAt: 5 put: expirations.
  			System _sessionCacheStatAt: 6 put: 0.
 			 expired := WABasicDevelopment reapSeasideCache.
  			expirations := expirations + 1.
			task state: expirations.
  			System _sessionCacheStatAt: 5 put: expirations.
  			System _sessionCacheStatAt: 6 put: expired.
  			expired > 0 ifTrue: [ (ObjectLogEntry trace: 'MTCE: expired sessions' object: expired) addToLog ].
  			GsFile gciLogServer: '...Expired: ', expired printString, ' sessions.'.
  			System commitTransaction.
  			System transactionMode: transactionMode ]
		reset: [:task | task state: 0 ]! !

!WAGemStoneMaintenanceTask class methodsFor: 'default maintenance tasks' stamp: 'DaleHenrichs 07/06/2010 17:11'!
maintenanceTaskMarkForCollect
	"self initialize"
	"self performTasks: 60"
	
	" run session MFC once each hour"
	
	^self 
		name: 'Mark For Collect'
		frequency: 60
		valuable: [:task | 
			GsFile gciLogServer: 'Starting markForCollect.: ', DateAndTime now printString.
      		[ 	
				System transactionMode == #autoBegin 
					ifTrue: [ System abortTransaction ]
					ifFalse: [ System beginTransaction ].
				SystemRepository markForCollection ] 
			  on: Error
        		  do: [:ex |
					((ex gsNumber == 3020) _or: [ex gsNumber == 3006])
					  ifTrue: [ | fileSize freeSpace used fileUnit freeUnit usedUnit converter |
					    fileSize := SystemRepository fileSize / 1024.0.
					    freeSpace := SystemRepository freeSpace / 1024.0.
					    used := fileSize - freeSpace.
					    fileUnit := fileSize > (1024)
					      ifTrue: [
					        fileSize := fileSize / 1024.
					        'M']
					      ifFalse: ['K'].
					    freeUnit := freeSpace > (1024)
					      ifTrue: [
					        freeSpace := freeSpace / 1024.
					        'M']
					      ifFalse: ['K'].
					    usedUnit := used > (1024)
					      ifTrue: [
					        used := used / 1024.
					        'M']
					      ifFalse: ['K'].
					    System transactionMode ~~ #autoBegin ifTrue: [ System beginTransaction ].
					    converter := GRNumberPrinter new precision: 2.
					    (ObjectLogEntry
					      trace: 'MTCE: Repository Size'
					      object: 'Repository: ', (converter print: fileSize) , fileUnit,
										    ', Free: ', (converter print: freeSpace), freeUnit,
										    ', Used: ', (converter print: used), usedUnit) addToLog.
					    (ObjectLogEntry trace: 'MTCE: MFC' object: ex) addToLog.
					    System commitTransaction.
					    GsFile gciLogServer: ex description]
					  ifFalse: [ex pass ]].
			GsFile gciLogServer: '...finished markForCollect.', DateAndTime now printString ]! !

!WAGemStoneMaintenanceTask class methodsFor: 'instance creation' stamp: 'DaleHenrichs 07/06/2010 14:33'!
name: aString frequency: aNumber valuable: aValuable

	^self name: aString frequency: aNumber valuable: aValuable reset: [:task | ]! !

!WAGemStoneMaintenanceTask class methodsFor: 'instance creation' stamp: 'DaleHenrichs 07/06/2010 14:16'!
name: aString frequency: aNumber valuable: aValuable reset: resetBlock

	^self new name: aString frequency: aNumber valuable: aValuable reset: resetBlock! !

!WAGemStoneMaintenanceTask class methodsFor: 'operations' stamp: 'DaleHenrichs 07/06/2010 15:28'!
performTasks: aCount
	"
	 self performTasks: 0.
	 self performTasks: 1.
	 self performTasks: 60.
	"
	
	self tasks do: [:task | task performTask: aCount ]! !

!WAGemStoneMaintenanceTask class methodsFor: 'operations' stamp: 'DaleHenrichs 07/06/2010 14:20'!
removeTaskNamed: aString

	| removals |
	removals := OrderedCollection new.
	self tasks do: [:task | task name = aString ifTrue: [ removals add: task ]].
	removals do: [: task | self tasks remove: task ].! !

!WAGemStoneMaintenanceTask class methodsFor: 'operations' stamp: 'DaleHenrichs 07/06/2010 14:42'!
resetTasks
	"self resetTasks"
	
	self tasks do: [:task | task reset ]! !

!WAGemStoneMaintenanceTask class methodsFor: 'operations' stamp: 'NorbertHartl 10/07/2010 18:33'!
taskNamed: aString

	^ self taskNamed: aString ifAbsent: [ ^nil ]! !

!WAGemStoneMaintenanceTask class methodsFor: 'operations' stamp: 'DaleHenrichs 07/06/2010 14:35'!
taskNamed: aString ifAbsent: absentBlock

	self tasks do: [:task | task name = aString ifTrue: [ ^task ]].
	^absentBlock value! !

!WAGemStoneMaintenanceTask class methodsFor: 'accessing' stamp: 'DaleHenrichs 07/06/2010 13:50'!
tasks

	Tasks == nil ifTrue: [ Tasks := OrderedCollection new ].
	^Tasks! !

!WAGemStoneMaintenanceTask methodsFor: 'accessing' stamp: 'DaleHenrichs 07/06/2010 13:55'!
frequency

   frequency == nil ifTrue: [ ^1 ].
   ^frequency! !

!WAGemStoneMaintenanceTask methodsFor: 'updating' stamp: 'DaleHenrichs 07/06/2010 13:56'!
frequency: newValue

   frequency := newValue! !

!WAGemStoneMaintenanceTask methodsFor: 'accessing' stamp: 'DaleHenrichs 07/06/2010 14:18'!
name

   ^name! !

!WAGemStoneMaintenanceTask methodsFor: 'updating' stamp: 'DaleHenrichs 07/06/2010 14:18'!
name: newValue

   name := newValue! !

!WAGemStoneMaintenanceTask methodsFor: 'initialization' stamp: 'DaleHenrichs 07/06/2010 14:33'!
name: aString frequency: aNumber valuable: aValuable reset:aBlock

	name := aString.
	frequency := aNumber.
	valuable := aValuable.
	resetBlock := aBlock.
	self reset.! !

!WAGemStoneMaintenanceTask methodsFor: 'execution' stamp: 'DaleHenrichs 07/06/2010 14:52'!
performTask: aCount

	(aCount \\ self frequency) = 0
		ifTrue: [ self valuable value: self ].! !

!WAGemStoneMaintenanceTask methodsFor: 'execution' stamp: 'DaleHenrichs 07/06/2010 14:51'!
reset

	self resetBlock value: self! !

!WAGemStoneMaintenanceTask methodsFor: 'accessing' stamp: 'DaleHenrichs 07/06/2010 14:11'!
resetBlock

   ^resetBlock! !

!WAGemStoneMaintenanceTask methodsFor: 'updating' stamp: 'DaleHenrichs 07/06/2010 14:11'!
resetBlock: newValue

   resetBlock := newValue! !

!WAGemStoneMaintenanceTask methodsFor: 'accessing' stamp: 'DaleHenrichs 07/06/2010 14:15'!
state

   ^state! !

!WAGemStoneMaintenanceTask methodsFor: 'updating' stamp: 'DaleHenrichs 07/06/2010 14:15'!
state: newValue

   state := newValue! !

!WAGemStoneMaintenanceTask methodsFor: 'accessing' stamp: 'DaleHenrichs 07/06/2010 13:55'!
valuable

   ^valuable! !

!WAGemStoneMaintenanceTask methodsFor: 'updating' stamp: 'DaleHenrichs 07/06/2010 13:55'!
valuable: newValue

   valuable := newValue! !

Object subclass: #WAGemStoneRunSeasideGems
	instanceVariableNames: 'name adaptorClass ports'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Seaside-GemStone-Tools-Production-Gems'!

!WAGemStoneRunSeasideGems class methodsFor: 'accessing' stamp: 'DaleHenrichs 07/09/2010 12:00'!
default

	Default == nil ifTrue: [ Default := self new ].
	^Default! !

!WAGemStoneRunSeasideGems class methodsFor: 'accessing' stamp: 'DaleHenrichs 07/09/2010 12:00'!
default: aWAGemStoneSeasideGems

	Default := aWAGemStoneSeasideGems! !

!WAGemStoneRunSeasideGems class methodsFor: 'control' stamp: 'DaleHenrichs 07/09/2010 12:02'!
defaultPortString

	| portString |
	portString := '"'.
	self default ports do: [:port | portString := portString, port asString, ' ' ].
	portString := portString, '"'.
	^portString! !

!WAGemStoneRunSeasideGems class methodsFor: 'running script' stamp: 'DaleHenrichs 07/09/2010 12:43'!
executeGemCommand: command

	| commandLine |
	Transcript cr; show: '---', command, ' Seaside gems', ' ('; show: TimeStamp now printString; show: ')'.
	commandLine := 
		(GsFile _expandEnvVariable: 'GEMSTONE' isClient: false), 
		'/seaside/bin/runSeasideGems30 ', 
		command, 
		' ', 
		self default name,
		' ', 
		self defaultPortString.
	Transcript cr; show: (System performOnServer: commandLine) withSqueakLineEndings.
	Transcript cr; show: '---Finished Seaside gems ', command, ' ('; show: TimeStamp now printString; show: ')'.! !

!WAGemStoneRunSeasideGems class methodsFor: 'running script' stamp: 'DaleHenrichs 07/09/2010 12:18'!
restartGems
	"self restartGems"

	self executeGemCommand: 'restart'! !

!WAGemStoneRunSeasideGems class methodsFor: 'running script' stamp: 'DaleHenrichs 07/09/2010 12:18'!
startGems
	"self startGems"

	self executeGemCommand: 'start'! !

!WAGemStoneRunSeasideGems class methodsFor: 'control' stamp: 'DaleHenrichs 07/09/2010 12:00'!
startGemServerOn: portInteger
	"use this method to start adaptor in a separate gem.
	 use #startOn: if starting from development vm"

	| default |
	default := self default.
	GRPlatform current seasideLogServerStart: default name port: portInteger.
	"The method not expected to return"
	self default startOn: portInteger! !

!WAGemStoneRunSeasideGems class methodsFor: 'running script' stamp: 'DaleHenrichs 07/09/2010 12:18'!
stopGems
	"self stopGems"

	self executeGemCommand: 'stop'! !

!WAGemStoneRunSeasideGems methodsFor: 'accessing' stamp: 'DaleHenrichs 07/09/2010 12:00'!
adaptorClass

	adaptorClass == nil
		ifTrue: [ 
			Smalltalk at: #WAFastCGIAdaptor ifPresent: [:cl | ^cl ].
			Smalltalk at: #WAGsSwazooAdaptor ifPresent: [:cl | ^cl ].
			Smalltalk at: #WASwazooAdaptor ifPresent: [:cl | ^cl ]].
	^adaptorClass! !

!WAGemStoneRunSeasideGems methodsFor: 'accessing' stamp: 'DaleHenrichs 07/09/2010 12:00'!
adaptorClass: anAdaptorClass

	adaptorClass := anAdaptorClass! !

!WAGemStoneRunSeasideGems methodsFor: 'accessing' stamp: 'DaleHenrichs 07/09/2010 12:00'!
name

	name == nil ifTrue: [ ^self adaptorClass name ].
	^name! !

!WAGemStoneRunSeasideGems methodsFor: 'accessing' stamp: 'DaleHenrichs 07/09/2010 12:00'!
name: aString 

	name := aString! !

!WAGemStoneRunSeasideGems methodsFor: 'accessing' stamp: 'DaleHenrichs 07/09/2010 12:00'!
ports

	ports == nil ifTrue: [ ports := self adaptorClass defaultPortList ].
	^ports! !

!WAGemStoneRunSeasideGems methodsFor: 'accessing' stamp: 'DaleHenrichs 07/09/2010 12:00'!
ports: aCollection 

	ports := aCollection! !

!WAGemStoneRunSeasideGems methodsFor: 'control' stamp: 'DaleHenrichs 07/09/2010 12:00'!
start

	self startOn: self ports first! !

!WAGemStoneRunSeasideGems methodsFor: 'control' stamp: 'DaleHenrichs 07/09/2010 12:00'!
startOn: port

	self adaptorClass startOn: port! !

!WAGemStoneRunSeasideGems methodsFor: 'control' stamp: 'DaleHenrichs 07/09/2010 12:00'!
stop

	self adaptorClass stop! !

Object subclass: #WAGemStoneRunSmalltalkServer
	instanceVariableNames: 'servers'
	classVariableNames: 'Singleton'
	poolDictionaries: ''
	category: 'Seaside-GemStone-Tools-Production-Gems'!

!WAGemStoneRunSmalltalkServer commentStamp: 'PaulDeBruicker 04/15/2011 12:56' prior: 0!
Using this you should be able to start a server in its own Gem!

!WAGemStoneRunSmalltalkServer class methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 13:13'!
addServer: aServer
	self singleton addServer: aServer.! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 14:32'!
addServerOfClass: aServerClass withName: aUniqueName on: anArrayOfPortNumbers

	self addServer: (WAGemStoneSmalltalkServer createServerOfClass: aServerClass withName: aUniqueName on: anArrayOfPortNumbers).! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'running script' stamp: 'PaulDeBruicker 04/15/2011 14:59'!
executeGemCommand: command for: server

	| commandLine |
	Transcript cr; show: '---', command, ' Seaside gems', ' ('; show: TimeStamp now printString; show: ')'.
	commandLine := 
		(GsFile _expandEnvVariable: 'GEMSTONE' isClient: false), 
		'/seaside/bin/runSmalltalkServer ', 
		command, 
		' ', 
		server name,
		' ', 
		server portString.
	Transcript cr; show: (System performOnServer: commandLine) withSqueakLineEndings.
	Transcript cr; show: '---Finished Seaside gems ', command, ' ('; show: TimeStamp now printString; show: ')'.! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 12:56'!
initSingleton
	Singleton := super new! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 14:12'!
new
	^self shouldNotImplement! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 14:10'!
removeServer: aName
	self singleton removeServer: aName.! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 15:00'!
removeServerNamed: aName
	self singleton removeServer: aName.! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'running script' stamp: 'PaulDeBruicker 04/15/2011 12:56'!
restartGems: server
	"self restartGems"

	self executeGemCommand: 'restart' for: server! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'running script' stamp: 'PaulDeBruicker 04/15/2011 14:52'!
restartGemsNamed: aName
	
self restartGems: (self serverNamed: aName)! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 13:15'!
serverNamed: aString
	^self singleton serverNamed: aString! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 14:51'!
serverNames
	^self singleton names asSortedCollection! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 16:26'!
serversOnPort: aPortNumber
	^self singleton serversOnPort: aPortNumber! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 12:56'!
singleton
	Singleton isNil ifTrue: [self initSingleton].
	^Singleton! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'running script' stamp: 'PaulDeBruicker 04/15/2011 12:56'!
startGems: server
	"self startGems"

	self executeGemCommand: 'start' for: server! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 15:19'!
startGemServer: serverName On: portInteger
	"use this method to start adaptor in a separate gem.
	 use #startOn: if starting from development vm"

	GRPlatform current seasideLogServerStart: serverName port: portInteger.
	"The method not expected to return"
	self startServer: serverName On: portInteger! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 15:15'!
startServer: serverName On: portInteger
(self serverNamed: serverName) startOn: portInteger! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'running script' stamp: 'PaulDeBruicker 04/15/2011 16:28'!
stopAllGems
	self singleton servers do: [:each | self stopGems: each].! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'running script' stamp: 'PaulDeBruicker 04/15/2011 16:26'!
stopGemOnPort: aPortNumber


(self serversOnPort: aPortNumber) do: [:each | self stopGems:each]! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'running script' stamp: 'PaulDeBruicker 04/15/2011 12:56'!
stopGems: server
	"self stopGems"

	self executeGemCommand: 'stop' for: server! !

!WAGemStoneRunSmalltalkServer class methodsFor: 'running script' stamp: 'PaulDeBruicker 04/15/2011 14:16'!
stopGemsNamed: aName
	
	self stopGems:(self serverNamed: aName).! !

!WAGemStoneRunSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 14:01'!
addServer: aServer
	(self serverNamed: aServer name) notNil 
		ifTrue: [^Error error: 'Server with that name already exists!!'].

	self servers add: aServer! !

!WAGemStoneRunSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 13:05'!
initialize
	servers:=Set new.! !

!WAGemStoneRunSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 13:00'!
names

	^self servers collect:[:each | each name].! !

!WAGemStoneRunSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 12:59'!
ports

	^self servers collect:[:each | each port].! !

!WAGemStoneRunSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 14:11'!
removeServer: aName
|server|
server :=self serverNamed:aName.
server ==nil ifFalse:[	servers remove: server]! !

!WAGemStoneRunSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 13:00'!
serverClasses

	^self servers collect:[:each | each serverClass].! !

!WAGemStoneRunSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 14:54'!
serverNamed: aString
	^self servers detect:[:each | each name = aString] ifNone:[nil]! !

!WAGemStoneRunSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 12:59'!
servers
	^servers! !

!WAGemStoneRunSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 13:02'!
serversOfClass: aClassName
	^servers select: [:each | each serverClass name = aClassName]! !

!WAGemStoneRunSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 16:24'!
serversOnPort: aPort
	^servers detect: [:each | each ports includes: aPort] ifNone:[nil]! !

Object subclass: #WAGemStoneSmalltalkServer
	instanceVariableNames: 'name serverClass ports'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-GemStone-Tools-Production-Gems'!

!WAGemStoneSmalltalkServer commentStamp: 'PaulDeBruicker 04/15/2011 15:26' prior: 0!
Holds a server that can run unattended in its own gem.  Each Name has to be unique.  Can have a single or multiple ports.  Each port will create a new gem that runs.  Must respond to #startOn: #stop, #port, #ports.

#startOn: should not exit or else the server process will stop.  !

!WAGemStoneSmalltalkServer class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 04/15/2011 14:31'!
createServerOfClass: aServerClass withName: aName on: anArrayOfPortNumbers
	^self new
		serverClass: aServerClass;
		name: aName;
		ports: anArrayOfPortNumbers;
		yourself.! !

!WAGemStoneSmalltalkServer methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 15:08'!
isRunning
	^self serverClass isRunning! !

!WAGemStoneSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 14:05'!
name

	name == nil ifTrue: [ ^self serverClass name ].
	^name! !

!WAGemStoneSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 12:55'!
name: aString 

	name := aString! !

!WAGemStoneSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 14:06'!
ports

	ports == nil ifTrue: [ ports := self serverClass defaultPortList ].
	^ports! !

!WAGemStoneSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 12:55'!
ports: aCollection 

	ports := aCollection! !

!WAGemStoneSmalltalkServer methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 14:59'!
portString
	| portString |
	portString := '"'.
	ports do: [:port | portString := portString, port asString, ' ' ].
	portString := portString, '"'.
	^portString! !

!WAGemStoneSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 12:55'!
serverClass
	^serverClass! !

!WAGemStoneSmalltalkServer methodsFor: 'accessing' stamp: 'PaulDeBruicker 04/15/2011 12:55'!
serverClass: aServer
	serverClass:= aServer! !

!WAGemStoneSmalltalkServer methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 12:55'!
start

	self startOn: self ports first! !

!WAGemStoneSmalltalkServer methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 14:05'!
startOn: port

	self serverClass startOn: port! !

!WAGemStoneSmalltalkServer methodsFor: 'control' stamp: 'PaulDeBruicker 04/15/2011 14:05'!
stop

	self serverClass stop! !

!WAServerAdaptor class methodsFor: '*seaside-gemStone-tools-production' stamp: 'DaleHenrichs 07/09/2010 12:03'!
defaultPortList

	^#(8080)! !
WAObjectLog initialize!
WAGemStoneMaintenanceTask initialize!
